#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "dijkstra.h"
#include "network.h"

/*=================================================================================*/
//	@fn		struct LINKLIST *dijkstra(struct NETWORK *network, struct NODE *o, struct NODE *d)
//	@brief	_CNXg@ŌoHf[^o͂֐
/*=================================================================================*/

struct LINKLIST *dijkstra(struct NETWORK *network, struct NODE *o, struct NODE *d){
	char *camma = ",";
	int i, nodesize;
	double mincost = DBL_MAX, nownodecost;
	int finish=0; //I_Bp
	struct NODE *pn, *zanteinode, *nownode;
	struct LINKLIST *pk, *newcell;
	struct HEAP *heap;
	struct LINKLIST *pnll;
	struct LIST *psn;
	pk = NULL;

	nownode = o;
	nownodecost = 0.0;

	nodesize = 0; //m[h̑vJEg
	//Sm[h̏l̐ݒ
	for(i = 0; i < HSIZE; i++){
	for(pn = network->node[i]; pn != NULL; pn = pn -> next){
		nodesize++;
		pn -> beforelink = NULL;
		if(pn == nownode){ //N_m[ĥƂ
			pn -> mincost = 0.0;
			pn -> state = 1;
		} else { //ȊȌꍇ
			pn -> mincost = DBL_MAX;
			pn -> state = 0;
		}
	}
	}

	//N_ȂA܂͋N_sꏊȂƂ̗O
	if(nownode == NULL || nownode -> nextlinklist == NULL){
		return NULL;
	}

	//I_܂ł̍ŒZRXgm܂ŌvZ
	i = 0;
	heap = NULL;
	while(i <= nodesize){
		i++;
		for( pnll = nownode -> nextlinklist; pnll != NULL; pnll = pnll -> next ){
			if( (pnll -> link -> d -> mincost) > nownodecost + (pnll -> link -> cost)){
				(pnll -> link -> d -> mincost) = nownodecost + (pnll -> link -> cost);
				(pnll -> link -> d -> beforelink) = pnll -> link;
				heap = addheap(heap, pnll -> link -> d);
			}
		}
		//m̂ōŏRXgm[h
		zanteinode = NULL;
		mincost = DBL_MAX;
		zanteinode = putheap(heap);
		heap = delheap(heap);

		if(zanteinode != NULL){
			zanteinode -> state = 1;
			nownode = zanteinode;
			nownodecost = zanteinode -> mincost;
			if(nownode == d){
				finish = 1;	
				break;
			}
		}
	}
	heap = alldelheap(heap);
	//ȂȂƂ
	if(finish == 0){
		return NULL;
	}
	//I_߂肵ȂoHAEgvbg
	nownode = d;
	while(nownode != o){
		// Vǉvf̂߂̃̈mۂ 
		newcell = malloc( sizeof(struct LINKLIST) );
		if( newcell == NULL ){
			puts( "s" );
		}
		newcell -> link = (nownode -> beforelink);
		newcell -> next = pk;
		pk = newcell;
		nownode = nownode -> beforelink -> o;
	}
	return pk;
	//
}

/*=================================================================================*/
//	@fn		struct HEAP* addheap(struct HEAP* heap, struct NODE *putnode)
//	@brief@q[vɉI
/*=================================================================================*/

struct HEAP* addheap(struct HEAP* heap, struct NODE *putnode){
	struct HEAP *now, *next, *newcell;
	int done = 0;
	
	newcell = malloc( sizeof(struct HEAP) );
	if( newcell == NULL ){
		puts( "s" );
	}
	newcell -> node = putnode;
	newcell -> left = NULL;
	newcell -> right = NULL;

	if(heap == NULL){
		return newcell;
	}

	now = heap;
	done = 0;

	while (done == 0){
		if( (now -> node -> mincost) > (putnode -> mincost) && now -> left != NULL){
			now = now -> left;
		} else if((now -> node -> mincost) <= (putnode -> mincost) && now -> right != NULL){
			now = now -> right;
		} else  if ( (now -> node -> mincost) > (putnode -> mincost) && now -> left == NULL){
			done = 1;
			now -> left = newcell;
		} else  if ( (now -> node -> mincost) <= (putnode -> mincost) && now -> right == NULL){
			done = 1;
			now -> right = newcell;
		}
	}
	return heap;
}

/*=================================================================================*/
//	@fn		struct NODE* putheap(struct HEAP* heap)
//	@brief@q[vŏRXgm[hoI
/*=================================================================================*/

struct NODE* putheap(struct HEAP* heap){
	struct HEAP *now, *del;
	struct NODE *returnnode;
	int done = 0;
	if(heap == NULL){
		returnnode = NULL;
	} else {
		now = heap;
		while(now -> left != NULL){
			now = now -> left;
		}
		returnnode = now -> node;
	}
	return returnnode;
}

/*=================================================================================*/
//	@fn		struct HEAP* delheap(struct HEAP* heap)
//	@brief@q[v폜I
/*=================================================================================*/

struct HEAP* delheap(struct HEAP* heap){
	struct HEAP *now, *del;
	int done = 0;
	if(heap == NULL){
	} else if(heap -> left == NULL){
		del = heap;
		heap = heap -> right;
		free(del);
	} else{
		now = heap;
		while(done == 0){
			if(now -> left -> left == NULL){
				done = 1;
			}else{
				now = now -> left;
			}
		}
		del = now -> left;
		now -> left = now -> left -> right;
		free(del);	
	}
	return heap;
}

/*=================================================================================*/
//	@fn		struct HEAP* alldelheap(struct HEAP* heap)
//	@brief@q[vS폜I
/*=================================================================================*/

struct HEAP* alldelheap(struct HEAP* heap){
	struct HEAP *now, *del;
	int done = 0;
	while(heap != NULL){
		if(heap -> left == NULL){
			del = heap;
			heap = heap -> right;
			free(del);
		} else{
			now = heap;
			while(done == 0){
				if(now -> left -> left == NULL){
					done = 1;
				}else{
					now = now -> left;
				}
			}
			del = now -> left;
			now -> left = now -> left -> right;
			free(del);	
		}
	}
	return heap;
}
