#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "io.h"
#include "network.h"
#include "od.h"

/*=================================================================================*/
//	@fn		struct NETWORK* set_node(char* fname, struct NETWORK* network)
//	@brief	m[hf[^̊i[
/*=================================================================================*/

struct NETWORK* set_node(char* fname, struct NETWORK* network){
	FILE *fp;
	struct NODE *newnode;
	int ret, cnt, count, hashno;
	char g[2048];
	char *glist[3];

	//m[h
	fp = fopen(fname, "r" );
	if( fp==NULL ){
		printf( "%st@CJ܂\n", fname );
		return NULL;
	}
	fscanf( fp, "%s", &g); //ŏ1sǂݍ
	count = 0;
	while( ( ret = fscanf( fp, "%s", &g ) ) != EOF ){
		cnt = split( g, "," , glist , 3);
		hashno = hash(glist[0]);	//nbVԍ
		newnode = malloc( sizeof(struct NODE) );
		strcpy( newnode -> id, glist[0]);	//m[hID
		newnode -> lat = atof(glist[1]);	//ܓx
		newnode -> lon = atof(glist[2]);	//ox
		newnode -> state = 0;				//l0
		newnode -> mincost = 0.0;			//l0.0
		newnode -> beforelink = NULL;		//lNULL
		newnode -> nextlinklist = NULL;		//lNULL
		newnode -> next = network -> node[hashno];
		network -> node[hashno] = newnode;
		count++;
	}
	printf( "m[hF%d\n", count );
	fclose( fp );
	return network;
}

/*=================================================================================*/
//	@fn		struct NETWORK* set_link(char* fname, struct NETWORK* network, double gamma, double c)
//	@brief	Nf[^̊i[
/*=================================================================================*/

struct NETWORK* set_link(char* fname, struct NETWORK* network, double gamma, double c){
	FILE *fp;
	struct NETWORK *newnw;
	struct NODE *newnode, *onode;
	struct LINK *newlink;
	struct LINKLIST *newnxlink;
	int ret, cnt, count, hashno;
	char g[2048];
	char *glist[5];
	//N
	fp = fopen(fname, "r" );
	if( fp==NULL ){
		printf( "%st@CJ܂\n", fname );
		return NULL;
	}
	fscanf( fp, "%[^\n]%*c", &g); //ŏ1sǂݍ
	count = 0;
	while( ( ret = fscanf( fp, "%[^\n]%*c", &g ) ) != EOF ){
		cnt = split( g, ",", glist , 5);
		hashno = hash(glist[0]);	//nbVԍ
		newlink = malloc( sizeof(struct LINK) );
		strcpy( newlink -> id, glist[0]);	//NID
		onode = search_node(glist[1], network);		//N_m[h̃|C^
		newlink -> o = onode;
			newnxlink = malloc( sizeof(struct LINKLIST) );	//N_m[h̎Nɂ̃Nǉ
			newnxlink -> link = newlink;
			newnxlink -> next = onode -> nextlinklist;
			onode -> nextlinklist = newnxlink;
		newlink -> d = search_node(glist[2], network);	//I_m[h̃|C^
		newlink -> length = distance(newlink->o->lat, newlink->o->lon, newlink->d->lat, newlink->d->lon);	//N
		newlink -> speed = atof(glist[4]);	//x
		newlink -> freecost = ( newlink -> length / (newlink -> speed / 3.6) ) / 60.0; //NƐx玩RRXgvZ
		newlink -> cost = ( newlink -> length / (newlink -> speed / 3.6) ) / 60.0;	//lɎRRXg
		newlink -> flow = 0.0;	//ʗʏl0
		newlink -> newflow = 0.0;	//ʗʏl0
		newlink -> capacity = atof(glist[3]) * gamma * c;	//Ԑ~Zv~ʗe
		newlink -> next = network -> link[hashno];
		network -> link[hashno] = newlink;
		count++;
	}
	printf( "NF%d\n", count );
	fclose( fp );
	return network;
}

/*=================================================================================*/
//	@fn		struct OD* set_od(char* fname, char* fname2, struct OD* od, struct NETWORK* network);
//	@brief	ODʒuWf[^NI_m[h߂
/*=================================================================================*/

struct OD* set_od(char* fname, char* fname2, struct OD* od, struct NETWORK* network){
	FILE *fp;
	struct OD *newod, *p;
	int ret, cnt, count;
	char g[2048];
	char *glist[5];
	//N
	fp = fopen(fname, "r" );
	if( fp==NULL ){
		printf( "%st@CJ܂\n", fname );
		return NULL;
	}
	fscanf( fp, "%[^\n]%*c", &g); //ŏ1sǂݍ
	count = 0;
	while( ( ret = fscanf( fp, "%[^\n]%*c", &g ) ) != EOF ){
		cnt = split( g, ",", glist , 5);
		newod = malloc( sizeof(struct OD) );
		newod -> olat = atof(glist[0]);
		newod -> olon = atof(glist[1]);
		newod -> dlat = atof(glist[2]);
		newod -> dlon = atof(glist[3]);
		newod -> onode = search_onode(network, newod->olat, newod->olon);
		newod -> dnode = search_dnode(network, newod->dlat, newod->dlon);
		newod -> flow = atof(glist[4]);
		newod -> next = od;
		od = newod;
		count++;
	}
	printf( "ODyAF%d\n", count );
	fclose( fp );

	fp = fopen( fname2, "w" );
	if( fp==NULL){
		printf( "%st@CJ܂\n", fname2 );
		return NULL;
	}
	fprintf( fp, "N_m[h,I_m[h,ʗ\n");
	for( p = od; p != NULL; p = p -> next ){
		fprintf( fp, "%s,%s,%f", p -> onode -> id, p -> dnode -> id, p -> flow);
		fprintf( fp, "\n");
	}
	fclose( fp );


	return od;
}

/*=================================================================================*/
//	@fn		struct OD* set_odnode(char* fname, struct OD* od, struct NETWORK* network);
//	@brief	ODf[^i[
/*=================================================================================*/

struct OD* set_odnode(char* fname, struct OD* od, struct NETWORK* network){
	FILE *fp;
	struct OD *newod;
	struct NODE *o, *d;
	int ret, cnt, count;
	char g[2048];
	char *glist[3];
	//N
	fp = fopen(fname, "r" );
	if( fp==NULL ){
		printf( "%st@CJ܂\n", fname );
		return NULL;
	}
	fscanf( fp, "%[^\n]%*c", &g); //ŏ1sǂݍ
	count = 0;
	while( ( ret = fscanf( fp, "%[^\n]%*c", &g ) ) != EOF ){
		cnt = split( g, ",", glist , 3);
		newod = malloc( sizeof(struct OD) );
		o = search_node(glist[0], network);
		d = search_node(glist[1], network);
		newod -> olat = o -> lat;
		newod -> olon = o -> lon;
		newod -> dlat = d -> lat;
		newod -> dlon = d -> lon;
		newod -> onode = o;
		newod -> dnode = d;
		newod -> flow = atof(glist[2]);
		newod -> next = od;
		od = newod;
		count++;
	}
	printf( "ODyAF%d\n", count );
	fclose( fp );

	return od;
}



/*=================================================================================*/
//	@fn		int split( char *str, const char *delim, char *outlist[], int maxitem)
//	@brief	񕪗
/*=================================================================================*/

int split( char *str, const char *delim, char *outlist[], int maxitem) {
    char *tk;
    int cnt = 0;
    tk = strtok( str, delim );
    while( tk != NULL && cnt < maxitem ) {
        outlist[cnt++] = tk;
        tk = strtok( NULL, delim );
    }
    return cnt;
}

/*=================================================================================*/
//	@fn		int output_node(char* file, struct NODE *node)
//	@brief	m[hAEgvbg
/*=================================================================================*/

int output_node(char* file, struct NODE *node){
	struct NODE *p;
	FILE *fp;
	char *fname = file;
	fp = fopen( fname, "w" );
	if( fp==NULL){
		printf( "%st@CJ܂\n", fname );
		return -1;
	}
	fprintf( fp, "ID,ܓx,ox,RXg\n");
	for( p = node; p != NULL; p = p -> next ){
		fprintf( fp, "%s,%f,%f,%f", p -> id, p -> lat, p -> lon, p -> mincost);
		fprintf( fp, "\n");
	}
	fclose( fp );
	return 0;
}

/*=================================================================================*/
//	@fn		int output_link(char* file, struct NETWORK *network)
//	@brief	NAEgvbg
/*=================================================================================*/

int output_link(char* file, struct NETWORK *network){
	struct LINK *pl;
	FILE *fp;
	char *fname = file;
	int i;
	fp = fopen( fname, "w" );
	if( fp==NULL){
		printf( "%st@CJ܂\n", fname );
		return -1;
	}
	fprintf( fp, "ID,O,D,ʗ\n");
	for( i=0; i < HSIZE ; i++){
	for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
		fprintf( fp, "%s,%s,%s,%f", pl->id,pl->o->id,pl->d->id, pl->flow);
		fprintf( fp, "\n");
	}
	}
	fclose( fp );
	return 0;
}