#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "network.h"


/*=================================================================================*/
//	@fn		struct NETWORK* set_networks()
//	@brief	lbg[Nf[^inbVe[uj̏
/*=================================================================================*/

struct NETWORK* set_networks(void){
	struct NETWORK* network;
	int i;
	network = malloc( sizeof(struct NETWORK) );
	for(i = 0; i < HSIZE ; i++){
		network -> node[i] = NULL;
	}
	for(i = 0; i < HSIZE ; i++){
		network -> link[i] = NULL;
	}
	return network;
}

/*=================================================================================*/
//	@fn		int hash(char* str)
//	@brief	ɑΉnbV֐
/*=================================================================================*/

int hash(char* str){
	int i, hashno = 0;
	for(i = 0; i < strlen(str) ; i++){
		hashno = hashno * 37 + str[i];
		if(hashno > HSIZE){ 
			hashno = hashno % HSIZE;
		}
	}
	return hashno;
}

/*=================================================================================*/
//	@fn		struct NODE* search_node(char* id, struct NETWORK *p)
//	@brief	m[ȟ
/*=================================================================================*/

struct NODE* search_node(char* id, struct NETWORK *p){
	struct NODE *q;
	int hashno;
	hashno = hash(id);
	for( q = p->node[hashno]; q != NULL; q = q -> next ){
		if( strcmp(q -> id, id) == 0){
			return q;
		}
	}
	return NULL;
}

/*=================================================================================*/
//	@fn		struct LINK* search_link(char* id, struct NETWORK *p)
//	@brief	Ň
/*=================================================================================*/

struct LINK* search_link(char* id, struct NETWORK *p){
	struct LINK *q;
	int hashno;
	hashno = hash(id);
	for( q = p->link[hashno]; q != NULL; q = q -> next ){
		if( strcmp(q -> id, id) == 0){
			return q;
		}
	}
	return NULL;
}

/*=================================================================================*/
//	@fn		double distance(double alat, double alon, double blat, double blon)
//	@brief	ܓxox狗Ԃ
/*=================================================================================*/

double distance(double alat, double alon, double blat, double blon){
	#define PI 3.141592653589793
	double x, y;
	x = 6370000.0 * cos( ( alat + blat ) * 0.5 * PI / 180.0 ) * ( alon - blon ) * PI / 180.0;
	y = 6370000.0 * ( alat - blat ) * PI / 180.0;
	return sqrt( x * x + y * y ) ;
}

/*=================================================================================*/
//	@fn		struct NODE* search_onode(struct NETWORK *p, double lat, double lon)
//	@brief	Ŋo\m[ȟ
/*=================================================================================*/

struct NODE* search_onode(struct NETWORK *p, double lat, double lon){
	struct LINK *q;
	struct NODE *minnode;
	double min;
	int i;
	min = DBL_MAX;
	minnode = NULL;
	for( i=0; i < HSIZE ; i++){
	for( q = p->link[i]; q != NULL; q = q -> next ){
		if( min > distance(q->o->lat, q->o->lon, lat, lon)){
			min = distance(q->o->lat, q->o->lon, lat, lon);
			minnode = q->o;
		}
	}
	}
	return minnode;
}

/*=================================================================================*/
//	@fn		struct NODE* search_dnode(struct NETWORK *p, double lat, double lon)
//	@brief	Ŋ蓞\m[ȟ
/*=================================================================================*/

struct NODE* search_dnode(struct NETWORK *p, double lat, double lon){
	struct LINK *q;
	struct NODE *minnode;
	double min;
	int i;
	min = DBL_MAX;
	minnode = NULL;
	for( i=0; i < HSIZE ; i++){
	for( q = p->link[i]; q != NULL; q = q -> next ){
		if( min > distance(q->d->lat, q->d->lon, lat, lon)){
			min = distance(q->d->lat, q->d->lon, lat, lon);
			minnode = q->d;
		}
	}
	}
	return minnode;
}

