#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include <math.h>
#include "od.h"
#include "io.h"
#include "network.h"

/*=================================================================================*/
//	@fn		struct NETWORK* assignment(struct NETWORK* network, struct OD* od, double alpha, double beta, char* oplink)
//	@brief	ύtz
/*=================================================================================*/

struct NETWORK* assignment(struct NETWORK* network, struct OD* od, double alpha, double beta, char* oplink){
	#define GR 1.6180339887	//
	#define THRES_DELTA 1.0 //XVʗʂ̍̎臒l
	#define THRES_XI 0.0001 //`T̎臒l
	struct NODE *onode, *dnode;
	struct LINK *pl;
	struct OD *po;
	struct LINKLIST *linklist, *pll;
	double xi, minxi, z, minz, delta, xi1, xi2, xi3;
	int i, n;
	n = 0;
	//s\@ŒZoHɔz
	for( i=0; i < HSIZE ; i++){
	for( pl = network->link[i]; pl != NULL; pl = pl -> next ){	//SŇʗʁEXVʗʂ0ɂ
		pl->flow = 0.0;
		pl->newflow = 0.0;
		pl->cost = bpr(pl->flow, pl->freecost, pl->capacity, alpha, beta);	//BPR֐ŃRXgvZ
	}
	}
	for( po = od; po != NULL; po = po -> next ){	//SODʗʂz
		linklist = dijkstra(network, po->onode, po->dnode);	//ʗ0̂Ƃł̍ŒZoHT
		for( pll = linklist; pll != NULL; pll = pll -> next ){
			pll->link->newflow += po->flow;		//oH̃NODʗʂ
		}
		free_linklist(linklist);
	}
	delta = DBL_MAX;
	while(delta > THRES_DELTA){
		n++;
		//NRXgXV
		for( i=0; i < HSIZE ; i++){
		for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
			pl->flow = pl->newflow;	//ʗʂXVꂽʗʂŏ
			pl->cost = bpr(pl->flow, pl->freecost, pl->capacity, alpha, beta);	//BPR֐ŃRXgvZ
		}
		}
		output_link(oplink, network);
		//VȃRXĝƂōŒZoHɔz
		for( i=0; i < HSIZE ; i++){
		for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
			pl->newflow = 0.0;	//SN̍XVʗʂ0ɂ
		}
		}
		for( po = od; po != NULL; po = po -> next ){
			linklist = dijkstra(network, po->onode, po->dnode);	//݂̃NRXĝƂł̍ŒZoHT
			for( pll = linklist; pll != NULL; pll = pll -> next ){
				pll->link->newflow += po->flow;	//oH̃NODʗʂ
			}
			free_linklist(linklist);
		}
		//`Ti@jxi߂
		minz = DBL_MAX;
		minxi = 0.0;
		//xi=0.01.0rxi1xi2
		if( fz(network,0.0,alpha,beta) < fz(network,1.0,alpha,beta)){
			xi1 = 1.0;
			xi2 = 0.0;
		} else {
			xi1 = 0.0;
			xi2 = 1.0;
		}
		//xi3߁AXVBxi1xi2͈̔͂iĂ
		while( fabs(xi1-xi2) > THRES_XI){
			xi3 = (xi1 * 1.0 + xi2 * GR)/(1.0+GR);
			if( fz(network,xi2,alpha,beta) < fz(network,xi3,alpha,beta)){
				xi1 = xi3;
			} else {
				xi1 = xi2;
				xi2 = xi3;
			}
		}
		minxi = xi2;
		minz = fz(network,xi2,alpha,beta);
		//minxipăNʗʍXVAldeltavZ
		delta = 0.0;
		for( i=0; i < HSIZE ; i++){
		for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
			delta += fabs( (pl->flow)*(minxi)+(pl->newflow)*(1-minxi) - (pl->flow) );
			pl->cost = bpr( (pl->flow)*(minxi)+(pl->newflow)*(1-minxi) , pl->freecost, pl->capacity, alpha, beta);
			pl->newflow = (pl->flow)*(minxi)+(pl->newflow)*(1-minxi);
		}
		}
		printf( "%dځ@@z = %f@@delta = %f@@xi = %f\n", n, minz , delta , minxi);
	}
	//ʗʂm肳
	for( i=0; i < HSIZE ; i++){
	for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
		pl->flow = pl->newflow;	//ʗʂXVꂽʗʂŏ
		pl->cost = bpr(pl->flow, pl->freecost, pl->capacity, alpha, beta);	//BPR֐ŃRXgvZ
	}
	}
	return network;
}

/*=================================================================================*/
//	@fn		int free_linklist(struct LINKLIST* linklist)
//	@brief	NXg̃@
/*=================================================================================*/

int free_linklist(struct LINKLIST* linklist){
	struct LINKLIST *del, *pll;
	while( linklist != NULL ){
		del = linklist;
		linklist = linklist -> next;
		free(del);
	}
	return 0;
}

/*=================================================================================*/
//	@fn		double fz(struct NETWORK* network, double xi, double alpha, double beta)
//	@brief	ύtzł̖ړI֐̌vZ
/*=================================================================================*/

double fz(struct NETWORK* network, double xi, double alpha, double beta){
	double z;
	int i;
	struct LINK *pl;
	z = 0.0;
	for( i=0; i < HSIZE ; i++){
	for( pl = network->link[i]; pl != NULL; pl = pl -> next ){
		pl->cost = bpr( (pl->flow)*(xi)+(pl->newflow)*(1-xi) , pl->freecost, pl->capacity, alpha, beta);
		z += (pl->cost)*((pl->flow)*(xi)+(pl->newflow)*(1-xi));
	}
	}
	return z;
}


/*=================================================================================*/
//	@fn		double bpr(double flow, double freecost, double capacity, double alpha, double beta)
//	@brief	BPR֐
/*=================================================================================*/

double bpr(double flow, double freecost, double capacity, double alpha, double beta){
	return freecost * (1.0 + alpha * pow(flow/capacity, beta));
}